<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:template="http://www.boddie.org.uk/ns/xmltools/template"
                version="1.0">

  <!-- Add or process comment elements inside item elements. -->
  <!-- This transformation must happen after type elements have been populated. -->

  <xsl:template match="item">
    <!-- Copy the element and its contents. -->
    <xsl:copy>
      <xsl:apply-templates select="@*"/>
      <!-- Only for certain element types... -->
      <xsl:if test="type/type-enum[@value='Personal' and @value-is-set]">
        <!-- Ensure a comment element. -->
        <xsl:call-template name="comment"/>
      </xsl:if>
      <xsl:apply-templates select="*[local-name() != 'comment']"/>
    </xsl:copy>
  </xsl:template>

  <!-- Investigate comment elements. -->

  <xsl:template name="comment">
    <!-- Make the element. -->
    <comment>
      <!-- Look for comment text. -->
      <xsl:apply-templates select="comment/@*"/>
    </comment>
  </xsl:template>

  <!-- Replicate unknown elements. -->

  <xsl:template match="@*|*|node()">
    <xsl:copy>
      <xsl:apply-templates select="@*|*|node()"/>
    </xsl:copy>
  </xsl:template>

</xsl:stylesheet>
